<?php
/*
Набор функций для построения wap сайтов.
Полное или частичное распространение запрещено.
Автор: Denvas
http://bmatrix.net/
*/
    define("TMPL","%");
    //проверка данных регуляркой
    $filterinput=array(
        "STRING10"=>array("^[^\x01]{0,10}$","Любые данные не длиннее 10 символов",1,array(),array(""=>1)),
        "STRING50"=>array("^[^\x01]{0,50}$","Любые данные не длиннее 50 символов",1,array(),array(""=>1)),
        "STRING150"=>array("^[^\x01]{0,150}$","Любые данные не длиннее 150 символов",1,array(),array(""=>1)),
        "STRING250"=>array("^[^\x01]{0,250}$","Любые данные не длиннее 250 символов",1,array(),array(""=>1)),
        "MAIL"=>array("^[a-zA-Z0-9_.-]+\@[a-zA-Z0-9_.-]+\.[a-zA-Z]{2,5}$","xxx@yyy.zz",1,array("#"=>"@"),array("@."=>1,"@"=>1,"."=>1)),
        "LOGIN"=>array("^[a-zA-Z0-9-]{3,50}$","латинские буквы, цифры и символ \"-\". Минимальная длинна 3 символа",1,array(),array(""=>1)),
        "PASSWORD"=>array("^[a-zA-Z0-9.,!#%*()]{3,20}$","от 3х латинских букв",0,array(),array(""=>1)),
        "INT"=>array("^\-?[0-9]*$","только цифры",1,array(),array(""=>1)),
        "FLOAT"=>array("^\-?[0-9]*\.?[0-9]*$","целаячасть.дробная",1,array(","=>"."),array("."=>1)),
        "IP"=>array("^[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}$","XXX.XXX.XXX.XXX",0,array(),array("...."=>1)),
        "WORD"=>array("^[0-9a-zA-Z_-]*$","только латинские буквы и цифры",1,array(),array(""=>1)),
        "URL"=>array("^(https?|HTTPS?|ftp|gopher):\/\/[a-zA-Z0-9_-]+(\.[a-zA-Z0-9-]+)*\.[a-zA-Z]{1,7}".// Основное имя сервера
          "(\/[a-zA-Z0-9\_\.-]*\/?)*". // Имена возможных подкаталогов и файл
          "[^\x01]{0,200}$"//get параметр
          ,"http://site.com/path/",1,array(),array("http://"=>1,"https://"=>1)),
        "SITE"=>array("^[a-zA-Z0-9_-]+(\.[a-zA-Z0-9-]+)*\.[a-zA-Z]{1,7}$"//get параметр
          ,"site.com",1,array(),array(""=>1)),
        "TIME"=>array("^[0-9]{2}(:[0-9]{2})?(:[0-9]{2})?$","часы:минуты:секунды",1,array(),array(":"=>1,"::"=>1,"ЧЧ:ММ:СС"=>1)),
        "DATE"=>array("^[0-9]{4}-[0-9]{2}-[0-9]{2}$","ГГГГ-ММ-ДД",1,array(),array("-"=>1,"--"=>1)),
        "DATETIME"=>array("^[0-9]{4}-[0-9]{2}-[0-9]{2}([ ]+[0-9]{2}:[0-9]{2}:[0-9]{2}){0,1}$","ГГГГ-ММ-ДД ЧЧ:ММ:СС",1,array(),array("ГГГГ-ММ-ДД ЧЧ:ММ:СС"=>1)),
        "NUMPHONE"=>array("^\+?[0-9 ()-]{5,20}$","только цифры",1,array(),array(""=>1,"+7"=>1)),
        "SESSION"=>array("^[0-9a-zA-Z]*$","правильная сессия",0,array(),array(""=>1)),
        "FILE"=>array("^[0-9a-zA-Z_.-]*$","только латинские буквы и цифры",1,array(),array(""=>1)),
    );
    //таблица преобразования символов при получении данных от пользователя
    $aDATAtoCODE=array(
        //защита от взломов
        "\r"=>"",
        "\n"=>"<br/>",
        "|"=>"&#x07C;",
        "\""=>"&quot;",
        "'"=>"&#039;",
        "<"=>"&lt;",
        ">"=>"&gt;",
    );
    //преобразование для получения xhtml
    $aCODEtoXHTML=array(
        "&quot;"=>"\"",
        "&#039;"=>"'",
        "&lt;"=>"<",
        "&gt;"=>">",
    );
    $aCODEtoDATA=array(
        "<br/>"=>"\n",
        "&#x07C;"=>"|",
        "&quot;"=>"\"",
        "&#039;"=>"'",
        "&lt;"=>"<",
        "&gt;"=>">",
    );

    //==================================================//
    /*
    Инициализация всей библиотеки
    */
    function FunctionInit(){
        global $user_agent, $ip, $srobot, $wapver, $curpath, $queryneed, $curfile, $robots, $gettopath, $maxwapver;
        start();

        if(!empty($gettopath)){
            $infoparam=ParsePath($_SERVER["REQUEST_URI"]);
            $_GET=array_merge($_GET,$infoparam[1]);
            $REQUEST_URI=$infoparam[0];
            $_SERVER['QUERY_STRING']=$infoparam[2];
        }
        elseif(isset($_SERVER["REQUEST_URI"])){
            $REQUEST_URI=$_SERVER["REQUEST_URI"];
        }
        else{
            $REQUEST_URI="/";
        };
        //обработка всех параметров
        AllParam();

        //определение параметров посетителя
        $user_agent=(isset($_SERVER['HTTP_USER_AGENT'])?$_SERVER['HTTP_USER_AGENT']:"");
        $ip=(isset($_SERVER['REMOTE_ADDR'])?$_SERVER['REMOTE_ADDR']:"");
        //пути на сервере
        $curpath=explode("?",$REQUEST_URI);
        $curfile=str_replace("\\","/",$curpath[0]);
        $curtemp=explode("/",rtrim(str_replace("\\","/",$curfile),"/"));
        if(strpos($curtemp[count($curtemp)-1],".")!==false)unset($curtemp[count($curtemp)-1]);
        $curpath=join("/",$curtemp)."/";

        //определение роботов
        $robots="";
        $_agentname=array(
            //поисковики
            array('Google',0,'google'),
            array('Yandex',0,'Yandex'),
            array('Rambler',0,'StackRambler'),
            array('MSN',0,'msnbot'),
            array('Aport',0,'Aport'),
            array('Yahoo',0,'help.yahoo.com'),
            //неизвестные роботы
            array('other robot',0,'http://'),    
        );
        $nagentname=count($_agentname);
        for($i=0;$i<$nagentname;$i++){
            if(strpos($user_agent,$_agentname[$i][2])!==false){
                $robots=$_agentname[$i][0];break;
            };
        };

        //версия отображения
        if(empty($wapver)){
            //выбрано пользователем
            if(!empty($_GET["wv"])){
                $wapver=(int)$_GET["wv"];
            }
			//занесено в куки
            elseif(!empty($_COOKIE["wv"])){
                $wapver=(int)$_COOKIE["wv"];
            }
            //для всех остальных вторую версию
            else
                $wapver=2;
			if($wapver<1)$wapver=1;
			if($wapver>$maxwapver)$wapver=$maxwapver;
        };//if(empty($wapver))
    
        //операмини - это особенный браузер :-)
        if(strpos($user_agent,"Opera Mini")!==false){
            /*
            $spos=strpos($user_agent," ");
            $user_agent=substr($user_agent,0,$spos)." ".@$_SERVER["HTTP_X_OPERAMINI_PHONE_UA"];
            $ip=@$_SERVER["X_FORWARDED_FOR"];
            */
            $user_agent="Opera Mini ".(isset($_SERVER["HTTP_X_OPERAMINI_PHONE_UA"])?$_SERVER["HTTP_X_OPERAMINI_PHONE_UA"]:"");
        };//if
		if((isset($_GET["uid"]))&&(!isset($_COOKIE["uid"]))){
			setcookie("uid",(int)$_GET["uid"],time()+30*24*60*60,$curpath);
		};
    };
    //==================================================//
    function formatinput($type){    
        global $filterinput;
        return $filterinput[$type][1];
    };
    //==================================================//
    /*
    Проверка значения на вводимые данные с возможной корректировкой данных
    */
    function checkinput(&$value,$type,$fempty=true){
        global $filterinput;
        if(strlen($value)==0)return $fempty;
        //описание формата
        if(empty($filterinput[$type]))return $fempty;//не найден формат
        $format=&$filterinput[$type];
        //замена переменных
        $value=strtr($value,$format[3]);
        //проверка на пустоту
        if(isset($format[4][$value])){$value="";return $fempty;};
        //проверка на регулярку
        return ereg($format[0],$value);
    };
    //==================================================//
    /*
    Вывод страницы
    */
    function ShowXML($code){
        global $template, $charset, $codereplace, $compressdata, $user_agent, $ip, $shifttime, $gettopath, $projectname, $maindomain;
        header($template["Content-type"]);

        $code=strtr($code,$codereplace);//заменить что-то на что-то
        $codereplace=array();
        $time=time()+$shifttime*60;
        $codereplace[TMPL."date".TMPL]=date($template["format_date"], $time);
        $codereplace[TMPL."time".TMPL]=date($template["format_time"], $time);

        $str=explode(" ",$user_agent);
        $codereplace[TMPL."uagent".TMPL]=$str[0];
        $codereplace[TMPL."ip".TMPL]=$ip;
        $codereplace[TMPL."unixtime".TMPL]=$time;

        $codereplace[TMPL."projectname".TMPL]=$projectname;
        $codereplace[TMPL."maindomain".TMPL]=$maindomain;
        $codereplace[TMPL."site".TMPL]=isset($_SERVER['HTTP_HOST'])?$_SERVER['HTTP_HOST']:"";

        $codereplace["<hr/>"]=$template["separator"];

        if(isset($template["h1"])){
            $elem=explode(TMPL."code".TMPL,$template["h1"]);
            if(isset($elem[1])){$codereplace["<h1>"]=$elem[0];$codereplace["</h1>"]=$elem[1];};
        };
        if(isset($template["h2"])){
            $elem=explode(TMPL."code".TMPL,$template["h2"]);
            if(isset($elem[1])){$codereplace["<h2>"]=$elem[0];$codereplace["</h2>"]=$elem[1];};
        };
        $code=replaceurl($code,$codereplace);//заменить что-то на что-то
        if(!empty($gettopath))$code=UrlPath($code);//подменить все гет запросы на пути

        if((!empty($compressdata))&&(isset($_SERVER["HTTP_ACCEPT_ENCODING"]))){
            if(strpos($_SERVER["HTTP_ACCEPT_ENCODING"],"gzip")!==false){
                $code = gzencode($code, 9);
                header("Content-encoding: gzip");
            }
            elseif(strpos($_SERVER["HTTP_ACCEPT_ENCODING"],"deflate")!==false){
                $code = gzdeflate($code, 9);
                header("Content-encoding: deflate");
            };
        };//if(isset($_SERVER["HTTP_ACCEPT_ENCODING"]))
        header("Content-Length: ".strlen($code));
        print $code;
    };
    //==================================================//
    /*
    Функция выставляющая заголовки кеширования
    */
    function HeaderCache($timecache=0,$updatetime=0){
        //не кешировать
        if($timecache==0){
            header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); //Дата в прошлом
            header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
            header("Pragma: no-cache"); // HTTP/1.0
        }
        //кешировать на кол-во секунд
        else{
            header("Cache-control: public");
            header("Cache-control: max-age=".$timecache);
        };
        //время последнего обновления страницы
        if($updatetime)
            header("Last-Modified: ".date("r", $updatetime));//когда реально обновлено
        else
            header("Last-Modified: ".date("r", time()));//обновлено сейчас
        
    };
    //==================================================//
    /*
    Пересылка на другую страницу с задержкой
    */
    function Relocation($url,$titlel="",$timeout=10,$templname="location"){
        global $wapver,$curpath,$template,$charset,$curfile,$codereplace, $gettopath, $globalcontent,$title, $interfacemessage;
        HeaderCache();
        if(strpos($url,"?")===0){
            $url=$curfile.$url;
        };
        if((strpos($url,"/")!==0)&&(strpos($url,"http://")===false)){
            $url=rtrim($curpath,"/\\")."/".$url;            
        };
        if(strpos($url,"http://")===false){
            if(!empty($gettopath))$url=QueryPath($url);
            $url="http://".@$_SERVER['HTTP_HOST'].$url;
        };
        if(!$titlel)$timeout=-1;
		elseif((!empty($_SESSION))&&(!empty($interfacemessage)))
			if(!empty($_POST))$timeout=1; else $timeout=-1;//выводить последнее сообщение
        if($timeout<0)header("Location: ".trim(strtr($url,array("&amp;"=>"&")),"&"));
        header($template["Content-type"]);
        if($wapver>1){$timeout=((int)($timeout/6));if($timeout<0)$timeout=1;};
		$repl=isset($globalcontent)?$globalcontent:array();
		$repl=array_merge($repl,array(TMPL."title".TMPL=>$title,TMPL."url".TMPL=>$url,TMPL."timeout".TMPL=>($timeout>0)?$timeout:1,TMPL."code".TMPL=>$titlel.((strpos($titlel,"<a")===false)?("<br/><a href='".$url."'>Дальше</a>"):"")));
        $code=strtr(isset($template[$templname])?$template[$templname]:$template["location"],$repl);
        ShowXML($code);
		if($titlel)$_SESSION["_showendtitle"]=date("H:i:s", time())." ".$titlel;
        exit;
    };
    //==================================================//
    /*
    Записать лог
    */
    function SaveLog($name="access",$str=""){
        global $path_log, $user_agent, $ip;
        $fd=fopen($path_log."/".$name.".log","ab");
        if($fd){
			reset($_POST);$strpost="";
			while(list($key,$val)=each($_POST))$strpost.=$key."=".$val."&";
            flock($fd,LOCK_EX);
            fwrite($fd,date("Y-m-d H:i:s", time())."|".$str."|http://".(isset($_SERVER['HTTP_HOST'])?$_SERVER['HTTP_HOST']:"").(isset($_SERVER["REQUEST_URI"])?$_SERVER["REQUEST_URI"]:"")."|".$user_agent."|".$ip."|".(isset($_SERVER['HTTP_COOKIE'])?$_SERVER['HTTP_COOKIE']:"")."|".(isset($_SERVER['HTTP_REFERER'])?$_SERVER['HTTP_REFERER']:"")."|".$strpost."\n");
            fclose($fd);
        };
    };
    //==================================================//
    /*
    Отображение переключения между страницами в таблицах
    */
    function ShowPage($name="",$newrowpage=0){
        global $nrowpage,$rows,$page,$template,$wapver;
        if(!$newrowpage)$newrowpage=$nrowpage;
        if($newrowpage<1)$newrowpage=1;//не может быть меньше 1 записи
        $code="";
        $urlpage=QueryParam("p_".$name)."p_".$name."=";
        if($rows>$newrowpage){
            //определение количества страниц
            $npage=(int)($rows/$newrowpage);if($npage*$newrowpage<$rows)$npage++;
            if($page>$npage)$page=$npage;
            //переход на следующую
            if($npage>$page)
                $pagenext=strtr($template["pagenext"],array(TMPL."url".TMPL=>$urlpage.($page+1),TMPL."page".TMPL=>$page+1));
            else
                $pagenext="";
            //переход на последнюю
            if($npage>$page+1)
                $pageend=strtr($template["pageend"],array(TMPL."url".TMPL=>$urlpage.$npage,TMPL."page".TMPL=>$npage));
            else
                $pageend="";
            //переход на предыдущую
            if($page>1)
                $pageprev=strtr($template["pageprev"],array(TMPL."url".TMPL=>$urlpage.($page-1),TMPL."page".TMPL=>$page-1));
            else
                $pageprev="";
            //переход на первую
            if($page>2)
                $pagebegin=strtr($template["pagebegin"],array(TMPL."url".TMPL=>$urlpage."1",TMPL."page".TMPL=>1));
            else
                $pagebegin="";
            //выбор из списка страниц (автоматически добавляется первая и последняя)
            $start=$page-5;if($start<3)$start=1;
            $stop=$page+5;if($stop>$npage-2)$stop=$npage;
            $pagesel="";
            for($i=$start;$i<=$stop;$i++){
                if($i==$page)//текущая страница
                    $pagesel.=strtr($template["pageselcur"],array(TMPL."url".TMPL=>$urlpage.$i,TMPL."page".TMPL=>$i));
                else//не текущая страница
                    $pagesel.=strtr($template["pagesel"],array(TMPL."url".TMPL=>$urlpage.$i,TMPL."page".TMPL=>$i));
            };//for
            if($start>1)$pagesel=$pagebegin.$pagesel;
            if($stop<$npage)$pagesel.=$pageend;
            //переход на произвольную страницу
            if($npage>5){
                $dataform=HiddenParam("p_".$name);
                $codehidden="";
                if($wapver==1)
                    $tmplhidden="<postfield name='".TMPL."name".TMPL."' value='".TMPL."value".TMPL."'/>";
                else
                    $tmplhidden="<input type='hidden' name='".TMPL."name".TMPL."' value='".TMPL."value".TMPL."'/>";
                for($i=0;$i<count($dataform);$i++){
                    $codehidden.=strtr($tmplhidden,array(TMPL."name".TMPL=>$dataform[$i][1],TMPL."value".TMPL=>$dataform[$i][2]));
                };
                $pageform=strtr($template["pageform"],array(TMPL."inputname".TMPL=>"p_".$name,TMPL."inputvalue".TMPL=>($npage>$page)?($page+1):$page,TMPL."hidden".TMPL=>$codehidden,TMPL."url".TMPL=>QueryParam(array())));
            }//if($npage>5)
            else
                $pageform="";
            $code=strtr($template["page"],array(TMPL."page".TMPL=>$page,TMPL."npage".TMPL=>$npage,TMPL."pagenext".TMPL=>$pagenext,TMPL."pageprev".TMPL=>$pageprev,TMPL."pageend".TMPL=>$pageend,TMPL."pagebegin".TMPL=>$pagebegin,TMPL."pageform".TMPL=>$pageform,TMPL."code".TMPL=>$pagesel));
        };//if($rows>$newrowpage)
        return $code;
    };//function ShowPage
    //==================================================//
    /*
    По глобальной переменной $rows выдает старт и стоп для выборки данных
    */
    function GetPage($name="",$newrowpage=0){
        global $nrowpage, $rows, $page;
        if(!$newrowpage)$newrowpage=$nrowpage;
        if($newrowpage<1)$newrowpage=1;
        if(empty($rows))return array(0,0);
        if(empty($_GET["p_".$name]))$page=1; else $page=(int)$_GET["p_".$name];
        $start=($page-1)*$newrowpage;
        if($start<0)$start=0;if($start>$rows-1)$start=$rows-1;
        $stop=$start+$newrowpage;if($stop>$rows)$stop=$rows;
        return array($start,$stop);
    };
    //==================================================//
    /*
    Скрытые гет параметры
    */
    function HiddenParam($paramname=array(),$invert=false, $querystr=""){
        global $query_rnd,$queryneed,$curfile;
        $data=array();
        if(strlen($querystr)==0)$querystr=$_SERVER['QUERY_STRING'];
        if(!is_array($paramname))$paramname=array($paramname);
        if($invert){
            reset($queryneed);while(list($key,$val)=each($queryneed))$paramname[]=$key;
        };
        $querystr=str_replace("&amp;","&",$querystr);
        $arr=explode("&",$querystr);$countarr=count($arr);
        for($i=0;$i<$countarr;$i++){
            if(empty($arr[$i]))continue;
            if(strpos($arr[$i],"help=")===0)continue;//помощь всегда отрезать
            if(strpos($arr[$i],"form_")===0)continue;//вывод раскрытой формы тоже всегда отрезать
            //if(strpos($arr[$i],"p_")===0)continue;//навигация по страницам
            $flag=$invert;
            for($j=0;$j<count($paramname);$j++)
                if(strpos($arr[$i],$paramname[$j]."=")===0){$flag=!$invert;break;};
            if($flag)continue;
            $appr=explode("=",$arr[$i]);
            if(!empty($appr[0]))$data[]=array("",$appr[0],isset($_GET[$appr[0]])?$_GET[$appr[0]]:"","hidden");
        };//for
        return $data;
    };//function QueryParam($paramname,$querystr)
    //==================================================//
    /*
    Возвращает путь + qet запрос
    */
    function QueryParam($paramname,$invert=false,$newfile="",$querystr="",$addparam=1){
        global $query_rnd,$queryneed,$curfile,$curpath;
        if(strlen($querystr)==0)$querystr=isset($_SERVER['QUERY_STRING'])?$_SERVER['QUERY_STRING']:"";
        if(!is_array($paramname))$paramname=array($paramname);
        $paramname[]="rnd";
        if($invert){
            reset($queryneed);while(list($key,$val)=each($queryneed))$paramname[]=$key;
        };
        $str="?";
        //заменить некоторые символы, чтоб избежать межсайтового скриптинга. в функции allparam стоит полная защита от таких символов
        $querystr=strtr($querystr,array("&amp;"=>"&","<"=>"\%3C",">"=>"\%3E","'"=>"\%27","\""=>"\%22"));
        $arr=explode("&",$querystr);$countarr=count($arr);
        $nparamname=count($paramname);
        for($i=0;$i<$countarr;$i++){
            if(empty($arr[$i]))continue;
            if(strpos($arr[$i],"form_")===0)continue;//вывод раскрытой формы тоже всегда отрезать
            if(strpos($arr[$i],"_")===0)continue;//все, что начинается с _ всегда отрезать
            $flag=$invert;
            for($j=0;$j<$nparamname;$j++){
                if(strpos($arr[$i],$paramname[$j]."=")===0){$flag=!$invert;break;};
            };
            if($flag)continue;
            $str.=$arr[$i]."&";
        };//for
        //эта фишка со случайными данными
        if(!empty($query_rnd))$str.="rnd=".mt_rand(0,10000)."&";
        //будут ли добавляться еще параметры
        if(!$addparam)$str=rtrim($str,"?&");
        //формирование названия файла
        if($newfile){
            //достроить путь до полного
            if(($newfile[0]!='/')&&($newfile[0]!='.'))$newfile=$curpath.$newfile;
        }
        else
            $newfile=$curfile;
        //вернем готовый урл
        return $newfile.str_replace("&","&amp;",$str);
    };//function QueryParam($paramname,$querystr)
    //==================================================//
    /*
    Функция для генерации случайных данных в названия для запрета кеширования в вапе
    */
    function IName($name,$rnd=0){
        if(empty($rnd))return $name;
        return $name."_".$rnd;
    };
    //==================================================//
    /*
    Вывод формы
    */
    function ShowForm($data,$replform,$action="",$method="post",$nameform="std",$nametemplate=""){
        global $wapver, $template;
        $extform=array();
        $rnd=mt_rand(1,100000);
        $code="";$codeform="";
        if(empty($action))$action=str_replace("&","&amp;",@$_SERVER["REQUEST_URI"]);
        if(strcmp($method,"get")==0){
            $action=explode("?",$action);
            $action=$action[0];
        };
        $repl=array("\""=>"&quot;","'"=>"&#039;","<"=>"&lt;",">"=>"&gt;",'%'=>"&#x25;","&"=>"&amp;");
        //для всех версий. вывод полей определяется шаблонами
        $ndata=count($data);
        if(strcmp($method,"post")==0){
            $codeform.=strtr($template["input.hidden"],array(TMPL."name".TMPL=>"send",TMPL."value".TMPL=>$rnd));
        };
        if($wapver>1)$rnd=0;//для веба скинуть эту переменную
        $k=0;$codegroup=array();
        for($j=0;$j<$ndata;$j++){
            list($title,$name,$value,$type)=$data[$j];
            if(strpos($type,"show")!==0)$value=strtr($value,$repl);//защититься, если это вставляем в поле формы
            if(strcmp($type,"system")==0)continue;//системные поля не отображаются
            $codeinput="";$codetitle="";
            $namei=IName($name,$rnd);
            $description=empty($data[$j][5])?"":$data[$j][5];
            $inputgroup=empty($data[$j][6])?(".".$j):$data[$j][6];
            if(strcmp($type,"hidden")!=0)$codetitle=$title;
            if(
                (strcmp($type,"text")==0)||
                (strcmp($type,"password")==0)||
                (strpos($type,"textarea")===0)
            ){
                if(isset($template["input.".$type.".".$name])){
                    $codeinput.=strtr($template["input.".$type.".".$name],array(TMPL."name".TMPL=>$namei,TMPL."value".TMPL=>$value,TMPL."nameform".TMPL=>$nameform));
                }
                elseif(isset($template["input.".$type])){
                    $codeinput.=strtr($template["input.".$type],array(TMPL."name".TMPL=>$namei,TMPL."value".TMPL=>$value,TMPL."nameform".TMPL=>$nameform));
                };
            }
            elseif((strpos($type,"select")===0)||(strcmp($type,"radio")==0)){
                $option=$data[$j][4];
                if($option){
                    reset($option);
                    if(strpos($type,"multi")===false){
                        $value_sel=array($value=>1);
                    }
                    else{
                        $tmp=explode(";",$value);
                        $ntmp=count($tmp);$value_sel=array();
                        for($i=0;$i<$ntmp;$i++)$value_sel[$tmp[$i]]=1;
                    };
                    while(list($key,$val)=each($option))$codeinput.=strtr($template["input.".$type.".option"],array(TMPL."name".TMPL=>$namei, TMPL."value".TMPL=>$key,TMPL."selected".TMPL=>((isset($value_sel[$key]))?$template["input.".$type.".selected"]:""),TMPL."code".TMPL=>$val));
                };
                $codeinput=strtr($template["input.".$type],array(TMPL."name".TMPL=>$namei,TMPL."value".TMPL=>$value,TMPL."code".TMPL=>$codeinput));
            }
            elseif(strcmp($type,"checkbox")==0){
                $codeinput.=strtr($template["input.".$type],array(TMPL."name".TMPL=>$namei,TMPL."code".TMPL=>"",TMPL."selected".TMPL=>((!empty($value))?$template["input.".$type.".selected"]:"")));
            }
            elseif(strcmp($type,"hidden")==0){
                $codeform.=strtr($template["input.".$type],array(TMPL."name".TMPL=>$name,TMPL."namei".TMPL=>$namei,TMPL."value".TMPL=>$value));
            }
            elseif(strpos($type,"show")===0){
                if(strlen($value)>0)$codeinput=$value;
                //будем передавать и просто отображаемые поля, на всякий случай (тест)
                $codeform.=strtr($template["input.hidden"],array(TMPL."name".TMPL=>$name,TMPL."namei".TMPL=>$namei,TMPL."value".TMPL=>$value));
            }
            elseif(strpos($type,"file")===0){
                $codeinput=strtr($template["input.file"],array(TMPL."name".TMPL=>$name,TMPL."value".TMPL=>$value));
                $extform["enctype"]="multipart/form-data";
            };
            //добавить скрытое поле (совместимость с wap1)
            if((strcmp($type,"hidden")!=0)&&(isset($template["input.paramhidden"])))
                $codeform.=strtr($template["input.paramhidden"],array(TMPL."name".TMPL=>$name,TMPL."namei".TMPL=>$namei,TMPL."value".TMPL=>$value));

            if(empty($codegroup[$inputgroup]))$codegroup[$inputgroup]=array();
            $codegroup[$inputgroup][]=array($codeinput,$codetitle,$name,$description);

        };//for($j=0;$j<count($data);$j++)
        $k=0;
        reset($codegroup);
        while(list($key,$val)=each($codegroup)){
            $nval=count($val);
            if($nval==1){
                list($codeinput,$codetitle,$name,$description)=$val[0];
                if($codeinput){
                    $code.=strtr(isset($template["forminput".$nametemplate])?$template["forminput".$nametemplate]:$template["forminput"],array(TMPL."title".TMPL=>$codetitle,TMPL."code".TMPL=>$codeinput,TMPL."name".TMPL=>$name,TMPL."alloc".TMPL=>$k%2,TMPL."i".TMPL=>$k+1,TMPL."description".TMPL=>$description));
                }
                elseif($codetitle)$code.=strtr(isset($template["formshow".$nametemplate])?$template["formshow".$nametemplate]:$template["formshow"],array(TMPL."title".TMPL=>$codetitle,TMPL."name".TMPL=>$name,TMPL."alloc".TMPL=>$k%2,TMPL."i".TMPL=>$k+1));
            }
            else{
                $arr=array();$groupname="";
                for($i=0;$i<$nval;$i++){
                    list($codeinput,$codetitle,$name,$description)=$val[$i];
                    $arr[]=strtr(isset($template["forminputgroup".$nametemplate])?$template["forminputgroup".$nametemplate]:$template["forminputgroup"],array(TMPL."title".TMPL=>$codetitle,TMPL."code".TMPL=>$codeinput,TMPL."name".TMPL=>$name,TMPL."description".TMPL=>$description));
                    $groupname.=$name;
                };
                $codetitle=$key;
                $codeinput=join("",$arr);
                $name=$groupname;
                if($codeinput){
                    $code.=strtr(isset($template["formgroupshow".$nametemplate])?$template["formgroupshow".$nametemplate]:$template["formgroupshow"],array(TMPL."title".TMPL=>$codetitle,TMPL."code".TMPL=>$codeinput,TMPL."name".TMPL=>$name,TMPL."alloc".TMPL=>$k%2,TMPL."i".TMPL=>$k+1,TMPL."description".TMPL=>$description));
                }
                elseif($codetitle)$code.=strtr(isset($template["formshow".$nametemplate])?$template["formshow".$nametemplate]:$template["formshow"],array(TMPL."title".TMPL=>$codetitle,TMPL."name".TMPL=>$name,TMPL."alloc".TMPL=>$k%2,TMPL."i".TMPL=>$k+1));
            };
            $k++;
        };

        $str="";while(list($key,$val)=each($extform))$str.=" ".$key."='".$val."'";
        if(!is_array($replform))$replform=array(TMPL."ftitle".TMPL=>$replform);
        $replform[TMPL."action".TMPL]=$action;
        $replform[TMPL."method".TMPL]=$method;
        $replform[TMPL."extparam".TMPL]=$str;
        $replform[TMPL."code".TMPL]=$code;
        $replform[TMPL."codeform".TMPL]=$codeform;
        $replform[TMPL."name".TMPL]=$nameform;
        return strtr(isset($template["form".$nametemplate])?$template["form".$nametemplate]:$template["form"],$replform);
    };
    //==================================================//
    /*
    Предварительная обработка GET и POST данных
    Функция преобразовывает в кодировку UTF-8 (если стоит параметр),
    заменяет опасные символы, транслитерирует
    */
    function AllParam(){
        global $nottrans,$charmapt,$charset, $aDATAtoCODE;
        //защита данных
        $charmaputf8all=$aDATAtoCODE;
    
        $str1=isset($_SERVER["REQUEST_URI"])?$_SERVER["REQUEST_URI"]:"/";
        $str2="";
        $str3="";
        reset($_GET);
        while(list($key,$val)=each($_GET)){
            $str2.=$key."=".$val."&";
            if(is_array($val)){continue;};
            if(!isset($nottrans[$key])){
                $_GET[$key]=strtr($val,$charmaputf8all);
                $val=preg_replace("/&(?!([a-z]{2,4};)|(#x\w{1,4};)|(#\w{1,4};))/s", "&amp;", $val);
            };
        };
    
        reset($_POST);
        while(list($key,$val)=each($_POST)){
            $str3.=$key."=".$val."&";
            if(is_array($val)){
                reset($val);$val2=array();
                while(list($k,$v)=each($val)){
                    $v=preg_replace("/&(?!([a-z]{2,4};)|(#x\w{1,4};)|(#\w{1,4};))/s", "&amp;", $v);
                    $val2[$k]=strtr($v,$charmaputf8all);
                };
                $_POST[$key]=join(";",$val2);
                continue;
            };
            //вообще не преобразовываем
            if(strpos($key,"raw_")===0){
                $_POST[$key]=$val;
            }
            //это форма с вводом html. ее править не нужно
            elseif(strpos($key,"html_")===0){
                $_POST[$key]=strtr($val,array("\r"=>"","\n"=>"<br/>"));
            }
            else{
                $val=preg_replace("/&(?!([a-z]{2,4};)|(#x\w{1,4};)|(#\w{1,4};))/s", "&amp;", $val);
                $_POST[$key]=strtr($val,$charmaputf8all);
            };
        };
    
        //защита от вставки левых данных
        if(
            (strcspn($str1,"\"'<>\0")!=strlen($str1))||
            (strcspn($str2,"\0\n\r")!=strlen($str2))||
            (strcspn($str3,"\0")!=strlen($str3))
          )NotFound("bad sim");
      
        return 0;
    };
    //==================================================//
    /*
    Принимает: $content - строка в которой искать,
               $left - ограничитель слева,
               $right - ограничитель справа
               $edit - перемещать ли $content на конец найденых данных
    Действие: Находит первое включение $left и $right, вырезая все, что между ними
    Возвращает: возвращает вырезанную часть
    */
    function getsubstr(&$content,$left,$right,$edit=false,$def=""){
        if($left)
            $startpos=strpos($content,$left);
        else
            $startpos=0;
        if(!($startpos===false)){
            $startpos+=strlen($left);
            if($right)
                $stoppos=strpos($content,$right,$startpos);
            else
                $stoppos=strlen($content);
            if($stoppos>0){
                $str=substr($content,$startpos,$stoppos-$startpos);
                if($edit)$content=substr($content,$stoppos+strlen($right));
                return $str;
            };
        };
        if($edit)$content="";
        return $def;
    };
    //==================================================//
    /*
    Преобразование урла к формату сайта.
    Добавляются и удаляются обязательные параметры
    */
    function NormalUrl($url){
        global $queryneed, $global_urlabsolute;
        if(strlen($url)==0)return QueryParam(array());
        if(stristr($url,"http://"))return $url;
        if(stristr($url,"mailto:"))return $url;
		if(stristr($url,"javascript:"))return $url;
        $elem=explode("?",strtr($url,array("&amp;"=>"&")));
        if(!isset($elem[1]))$elem[1]="";
        $param=array();
        $param1=explode("&",$elem[1]);$nparam=count($param1);
        for($i=0;$i<$nparam;$i++){
            $p=strpos($param1[$i],"=");
            $param[substr($param1[$i],0,$p)]=substr($param1[$i],$p+1);
        };//for
        //это то же самое, что чуть повыше, только с глюками в кодировании parse_str($elem[1],$param);
        $get=array();
        $temp=$queryneed;
        $arr=array();
        while(list($key,$val)=each($param)){
            unset($queryneed[$key]);
            if(strlen($val)>0)
                $get[]=$key."=".$val;//внимание! если здесь использовать urlencode, то шаблоны %name% портятся
            elseif(isset($_GET[$key]))$get[]=$key."=".urlencode($_GET[$key]);
        };//while
        //$url=QueryParam($arr,0,$elem[0]).join("&amp;",$get);
        $url=str_replace("&","&amp;",rtrim(str_replace("&amp;","&",QueryParam(array(),1,$elem[0])).join("&",$get),"&?"));
        if(!empty($global_urlabsolute))$url="http://".@$_SERVER['HTTP_HOST']."/".ltrim($url,"/");
        $queryneed=$temp;
        return $url;
    };
    //==================================================//
    /*
    Подстановка в урл контекста
    Обрабатываются только ссылки в двойных кавычках.
    Двойные кавычки меняются на одинарные, чтоб случайно больше не заменить.
    */
    function replaceurl(&$content,$repl=array("\r"=>"","\n"=>" ")){
        if($repl)$content=strtr($content,$repl);
        $newcontent=$content;$repl=array();//можно обнулить, т.к. предыдущие уже заменили
        while($str=getsubstr($newcontent,'<a href="','"',true)){            
            if(strpos($str,"http://")===0){
                if(isset($_GET["ses"])||isset($_GET["sid"])){
                    //абсолютные пути уходят через специальный скрипт, если у нас есть сессия
                    $repl["<a href=\"".$str."\""]="<a href='go.php?url=".urlencode($str)."'";
                };
                continue;
            };
            $repl["<a href=\"".$str."\""]="<a href='".NormalUrl($str)."'";
        };//while
        return strtr($content,$repl);
    };
    //==================================================//
    /*
    Страница не найдена
    */
    function NotFound($code=""){
        global $template;
        SaveLog("notfound",$code);
        Relocation("http://".$_SERVER['HTTP_HOST']."/error.php","",-1);
        /*
        header($_SERVER['SERVER_PROTOCOL']." 404 Not Found");
        $code=strtr($template["main"],array(TMPL."title".TMPL=>"404 Not Found",TMPL."code".TMPL=>"404 Not Found ".$_SERVER["REQUEST_URI"]."<br/>".$code));
        ShowXML($code);
        exit;
        */
    };
    //==================================================//
    /*
    Преобразование урлов в полные ссылки
    Если $type==0 то генерирует html, иначе bbcode
    */
    function UrlInText($content,$type=0){
        $str=strtr($content,"<>,'\"","     ")." ";$repl=array();
        while($url=getsubstr($str,"http://"," ",1)){
            $url=rtrim($url,"<>.,(:)ёйцукенгшщзхъфывапролджэячсмитьбюЁЙЦУКЕНГШЩЗХЪФЫВАПРОЛДЖЭЯЧСМИТЬБЮ\r\n");//удалить из конца ссылки возможные глюки
            if($type==0){
                $repl["http://".$url]="<a href='http://".$url."'>http://".$url."</a>";
            }
            else{
                $repl["http://".$url]="[url]http://".$url."[/url]";
            };
        };
        return strtr($content,$repl);
    };
    //==================================================//
    /*
    Вывод ошибки и завершение программы
    */
    function Error($error){
        global $template, $title, $globalcontent;
        $code=strtr($template["fatalerror"],array(TMPL."urlrefresh".TMPL=>QueryParam(array())));
		$globalcontent[TMPL."code".TMPL]=$code;
		$globalcontent[TMPL."title".TMPL]=$title;
        ShowXML(strtr($template["main"],$globalcontent));
        SaveLog("error",$error);
        exit;
    };//function Error
    //==================================================//
    /*
    Отправить письмо
    */
    function SendMail($to,$subject,$message,$from=""){
        global $mail_text,$admin_email,$smtp_serv,$smtp_user,$smtp_pass,$charset;
        if(empty($to))return false;
        include_once("class_sendmail.php");
        $mails=new SendMailClass();
        $mails->SetCharset($charset);
        $mails->Mail(($from)?array($admin_email,$from):$admin_email,$to,$subject,trim($message)."\n".$mail_text);
        $mails->SMTPConf($smtp_serv,$smtp_user,$smtp_pass);
        $mails->Send();
        return true;
    };
    //==================================================//
    /*
    Отправить шаблонное письмо
    */
    function SendMailTemplate($to,$nametemplate,$replace=array(),$from=""){
        global $path_text,$projectname,$maindomain;
        $namefile=$path_text."/mail_".$nametemplate.".txt";
        if(!file_exists($namefile))return;
        $replace[TMPL."projectname".TMPL]=$projectname;
        $replace[TMPL."site".TMPL]=$maindomain;
        $data=@file($namefile);
        $subject=trim($data[0]);
        $message="";for($i=1;$i<count($data);$i++)$message.=trim($data[$i])."\n";
        SendMail($to,strtr($subject,$replace),strtr(strtr($message,$replace),array("<br/>"=>"\n","&amp;"=>"&")),$from);
    };
    //==================================================//
    /*
    Отображение текста с переключением по страницам
    */
    function ViewText($namefile,$replace=array(),$fatal=false,$codebr="<br/>",$namepage=""){
        global $nrowpage, $rows, $page, $path_text, $maindomain;
        $code="";$keyword="";
        $replace[TMPL."site".TMPL]=$maindomain;
        $content=@file($path_text."/".$namefile.((strpos($namefile,".txt")===false)?".txt":""));
        $rows=count($content)-1;
        if($rows<0)if($fatal)NotFound("Not file ".$namefile); else return array();
        $context=explode("|",trim($content[0]));
        $title=$context[0];
		$meta=empty($context[6])?$context[0]:$context[6];
        $newrowpage=isset($_GET["r"])?(int)$_GET["r"]:(empty($context[1])?$nrowpage:$context[1]);//количество записей на страницу
        if(!empty($context[2]))$keyword=$context[2];//ключевые слова
        list($start,$stop)=GetPage($namepage,$newrowpage);
        $code=(!empty($context[3]))?$context[3]:"";
        //вывод с добавлением перевода строки
        if(empty($context[5])){
            for($j=$start;$j<$stop;$j++)$code.=trim($content[$j+1]).$codebr;
        }
        //череcстрочный вывод
        elseif($context[5]==1){
            for($j=$start;$j<$stop;$j++)$code.=design(trim($content[$j+1]),"line".$j%2);
        }
        //вывод без изменения структуры
        else{
            for($j=$start;$j<$stop;$j++)$code.=$content[$j+1];
        };
        $code.=(!empty($context[4]))?$context[4]:"";
        $code=replaceurl($code,$replace);//заменить ссылки
        $code.=ShowPage($namepage,$newrowpage);
        return array($code,$title,$keyword,$meta);
    };
    //==================================================//
    /*
    Распарсивание данных
    */
    function ParseKeyVal($content,$repl=array(),$ll="",$rr=""){
        $ncontent=count($content);$name="";
        for($j=1;$j<$ncontent;$j++){
            $line=trim($content[$j]);
            if(empty($line))continue;
            $pos=strpos($line,":==");
            if($pos===false){
                $repl[$name].=$line;
                continue;
            };
            $name=$ll.substr($line,0,$pos).$rr;
            $value=substr($line,$pos+3);
            $repl[$name]=$value;
        };//for
        return $repl;
    };
    //==================================================//
    /*
    Действие: находит количество милисекунд. используется для подсчета времени выполнения
    Возвращает: возвращает количество милисекунд
    */
    function getmicrotime(){
        list($usec, $sec) = explode(" ",microtime());
        return ((float)$usec + (float)$sec);
    } ;
    //==================================================//
    /*
    Действие: засекает время старта программы
    */
    function start(){
        global $time_start;
        $time_start = getmicrotime();
    };
    //==================================================//
    /*
    Действие: засекает время останова программы и считает врмя выполнения
    Возвращает: время между вызовом start и stop
    */
    function stop(){
        global $time_start;
        $time_end = getmicrotime();
        $time = sprintf("%.6f",$time_end - $time_start);
        return $time;
    };
    //==================================================//
    /*
    перевод в нижний регистр
    */
    function mylower($str){
        return strtr($str,array("Q"=>"q","W"=>"w","E"=>"e","R"=>"r","T"=>"t","Y"=>"y","U"=>"u","I"=>"i","O"=>"o","P"=>"p","A"=>"a","S"=>"s","D"=>"d","F"=>"f","G"=>"g","H"=>"h","J"=>"j","K"=>"k","L"=>"l","Z"=>"z","X"=>"x","C"=>"c","V"=>"v","B"=>"b","N"=>"n","M"=>"m","Й"=>"й","Ц"=>"ц","У"=>"у","К"=>"к","Е"=>"е","Н"=>"н","Г"=>"г","Ш"=>"ш","Щ"=>"щ","З"=>"з","Х"=>"х","Ъ"=>"ъ","Ф"=>"ф","Ы"=>"ы","В"=>"в","А"=>"а","П"=>"п","Р"=>"р","О"=>"о","Л"=>"л","Д"=>"д","Ж"=>"ж","Э"=>"э","Я"=>"я","Ч"=>"ч","С"=>"с","М"=>"м","И"=>"и","Т"=>"т","Ь"=>"ь","Б"=>"б","Ю"=>"ю","Ё"=>"ё"));
    };
    //==================================================//
    /*
    Генерация уникального ID
    */
    function GenID($name){
        global $path_data;
        return time();
    };
    //==================================================//
    /*
    Замена переменных
    */
    function ReplaceContent(&$code,$namefile,$replurl=1){
        global $replaceformcontent, $path_text;
        if(empty($replaceformcontent)){
            $replaceformcontent=array();
            if(!empty($namefile)){
                $replaceformcontent=ParseKeyVal(file($path_text."/".$namefile.".txt"));
            };//if
        };//if(empty($replaceform))
        //замена переменных, поддержка сложных конструкций вплоть до phpBB
        reset($replaceformcontent);
        while(list($key,$val)=each($replaceformcontent)){
            if(strlen($key)==0)continue;
            if(strpos($key,TMPL.TMPL)!==false){
                $key=explode(TMPL.TMPL,$key);
                $nfind=count($key);$rep=100;
                while($find=ParseReplace($code,$key)){
                    $repl=array();
                    for($i=1;$i<$nfind;$i++){
                        $repl[TMPL.$i.TMPL]=$find[$i];
                    };
                    if(strlen($find[0])>0)
                        $code=strtr($code,array($find[0]=>strtr($val,$repl)));
                    $rep--;if($rep<0)break;
                };//while
            };//if
        };//while(list($key,$val)=each($replaceformcontent))
        if($replurl)
            $code=replaceurl($code,$replaceformcontent);
        else
            $code=strtr($code,$replaceformcontent);
    };//function ReplaceContent
    //==================================================//
    /*
    Функция выбора данных для сложных замен типа BB кода
    */
    function ParseReplace(&$content,$find){
        $nfind=count($find);
        $pp=$p=false;$search=array();
        for($i=0;$i<$nfind;$i++){
            if(strlen($find[$i])>0)$p=strpos($content,$find[$i],$pp);
            if($p===false)return array();
            if($i>0)$search[$i]=substr($content,$pp,$p-$pp); else $pstart=$p;
            $pp=$p+strlen($find[$i]);
        };
        $search[0]=substr($content,$pstart,$pp-$pstart);
        return $search;
    };

?>